package it.sc.xmpplugin.gui;

import it.sc.xmpplugin.main.GestioneXMP;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author Salvo Corsaro
 */
public class RdfUI extends javax.swing.JPanel {

    private JFileChooser fc = null;
    private Container container;

    /**
     * Creates new form RdfUI
     */
    public RdfUI() {
        initComponents();
    }

    public RdfUI(String pathFileSource, String fileName) {
        initComponents();
        jLabel2.setText(fileName);
        jTextArea1.setText(caricaRDFStructure(pathFileSource));
    }

    private String caricaRDFStructure(String pathFile) {
        return GestioneXMP.getRDFStructure(pathFile);
    }

    public JDialog RdfUIDialog(String pathFileSource, String fileName) {

        boolean isModale = true;
        RdfUI panel = new RdfUI(pathFileSource, fileName);
        return creaDialog(panel, isModale);
    }

    private void salvaSuFile() throws Exception {

        try {

            fc = new JFileChooser();
            int returnVal = fc.showSaveDialog(RdfUI.this);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                final File file = fc.getSelectedFile();
                PrintWriter pw = new PrintWriter(new FileOutputStream(file, true));
                pw.print(jTextArea1.getText());
                pw.close();
            }
            
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("Impossbile salvare struttura RDF su file.");
        }
    }

    private static JDialog creaDialog(RdfUI panel, boolean modale) {

        final JDialog dialog = new JDialog();

        GridLayout gridLayout = new GridLayout(1, 1);
        dialog.setLayout(gridLayout);
        dialog.setTitle("Struttura RDF");
        dialog.setMinimumSize(panel.getMinimumSize());
        dialog.setLocationRelativeTo(null);
        dialog.add(panel);
        panel.setContainer(dialog);
        panel.setVisible(true);
        dialog.pack();
        dialog.setResizable(false);
        dialog.setModal(modale);
        dialog.setVisible(true);
        dialog.requestFocus();

        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        int x = (int) ((dim.getWidth() - dialog.getWidth()) / 2);
        int y = (int) ((dim.getHeight() - dialog.getHeight()) / 2);
        dialog.setLocation(x, y);

        WindowListener wndCloser = new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                System.out.println("\n*** Chiusura della finestra. ***\n");
                dialog.dispose();
            }
        };
        dialog.addWindowListener(wndCloser);

        return dialog;
    }

    private Container getContentPane() {
        return this;
    }

    private void dispose() {
        if (container instanceof JDialog) {
            ((JDialog) container).dispose();
        } else {
            this.setVisible(false);
        }
    }

    public void setContainer(Container c) {

        this.container = c;
    }

    public Container getContainer() {

        return container;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();

        jTextArea1.setEditable(false);
        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jButton1.setText("Salva");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Chiudi");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel1.setText("Struttura RDF");

        jLabel2.setText("jLabel2");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jScrollPane1))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(140, Short.MAX_VALUE)
                .addComponent(jButton1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton2)
                .addGap(170, 170, 170))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(5, 5, 5)
                .addComponent(jLabel1)
                .addGap(3, 3, 3)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 243, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton2)
                    .addComponent(jButton1))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        boolean errore = false;
        try {
            salvaSuFile();
        } catch (Exception ex) {
            errore = true;
            JOptionPane.showMessageDialog(null, "Errore: " + ex.getMessage(),
                    "Errore", JOptionPane.ERROR_MESSAGE);
        }
        if(!errore) {
            JOptionPane.showMessageDialog(null, "File salvato correttamente.",
                    "Info", JOptionPane.INFORMATION_MESSAGE);
            dispose();
        }
        
    }//GEN-LAST:event_jButton1ActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    // End of variables declaration//GEN-END:variables
}
