package it.sc.xmpplugin.gui;

import it.sc.xmpplugin.Costanti;
import it.sc.xmpplugin.jpeg.JpegPicture;
import it.sc.xmpplugin.jpeg.JpegWriter;
import it.sc.xmpplugin.jpeg.XMPManager;
import it.sc.xmpplugin.main.GestioneXMP;
import it.sc.xmpplugin.presentation.FormData;
import it.sc.xmpplugin.utils.ValidazioneUtil;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

/**
 *
 * @author Salvo Corsaro
 */
public class XMPMetadataUI extends javax.swing.JPanel {

    private Container container;
    private String pathFileSource;
    private String fileName;
    private JFileChooser fc = null;
    //private static XMPMetadataUI istanza = null;

    /**
     * Creates new form XMPMetadataUI
     */
    public XMPMetadataUI() {
        initComponents();
    }

    public XMPMetadataUI(FormData dc, String pathFile, String fileName) {
        try {
            ij.util.Java2.setSystemLookAndFeel();
            initComponents();
            this.pathFileSource = pathFile;
            this.fileName = fileName;
            popolaForm(dc);

            /*  
             * si abilita il pulsante "salva" oppure il pulsante "modifica"
             * in base alla presenza o meno di dati XMP nel file selezionato
             */
            if (dc == null) {
                jButton4.setEnabled(false);
                jButton1.setEnabled(true);
                jButton3.setEnabled(false);
            } else {
                jButton4.setEnabled(true);
                jButton1.setEnabled(false);
                jButton3.setEnabled(true);
            }
            //jPanel3.setVisible(false);
        } catch (Exception ex) {
            Logger.getLogger(XMPMetadataUI.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    /*
     public static synchronized XMPMetadataUI getIstance(Point location) {
     if (istanza == null) {
     istanza = new XMPMetadataUI(location);
     }
     return istanza;
     }
     */
    public JDialog xmpMetadataUIDialog(FormData dc, String pathFile, String fileName) {

        boolean isModale = true;
        XMPMetadataUI panel = new XMPMetadataUI(dc, pathFile, fileName);
        return creaDialog(panel, isModale, fileName);
    }

    private static JDialog creaDialog(XMPMetadataUI panel, boolean modale, String fileName) {

        final JDialog dialog = new JDialog();

        GridLayout gridLayout = new GridLayout(1, 1);
        dialog.setLayout(gridLayout);
        dialog.setTitle(fileName);
        dialog.setMinimumSize(panel.getMinimumSize());
        dialog.setLocationRelativeTo(null);
        dialog.add(panel);
        panel.setContainer(dialog);
        panel.setVisible(true);
        dialog.pack();
        dialog.setResizable(false);
        dialog.setModal(modale);
        dialog.setVisible(true);
        dialog.requestFocus();

        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        int x = (int) ((dim.getWidth() - dialog.getWidth()) / 2);
        int y = (int) ((dim.getHeight() - dialog.getHeight()) / 2);
        dialog.setLocation(x, y);

        WindowListener wndCloser = new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                System.out.println("\n*** Chiusura della finestra. ***\n");
                dialog.dispose();
            }
        };
        dialog.addWindowListener(wndCloser);

        return dialog;
    }

    private Container getContentPane() {
        return this;
    }

    private void dispose() {
        if (container instanceof JDialog) {
            ((JDialog) container).dispose();
        } else {
            this.setVisible(false);
        }
    }

    public void setContainer(Container c) {

        this.container = c;
    }

    public Container getContainer() {

        return container;
    }

    private void popolaForm(FormData dc) {
        //jLabel18.setText(this.fileName);
        if (dc != null) {
            jPanel3.setVisible(false);
            jTextField1.setText(getStringFromList(dc.getAutori()));
            jTextField1.setSize(6, 22);
            jTextField1.setPreferredSize(new Dimension(6, 22));
            jTextArea1.setText(dc.getDescrizione());
            jTextField3.setText(dc.getTitolo());
            jTextField4.setText(getStringFromList(dc.getSoggetti())); // soggetti
            jTextField4.setSize(6, 22);
            jTextField4.setPreferredSize(new Dimension(6, 22));
            jTextField5.setText(getStringFromList(dc.getEditori())); // editori
            jTextField5.setSize(6, 22);
            jTextField5.setPreferredSize(new Dimension(6, 22));
            jTextField6.setText(getStringFromListDate(dc.getDate())); // date
            jTextField6.setSize(6, 22);
            jTextField6.setPreferredSize(new Dimension(6, 22));
            jTextField7.setText(getStringFromList(dc.getTipi())); // tipi
            jTextField7.setSize(6, 22);
            jTextField7.setPreferredSize(new Dimension(6, 22));
            jTextField8.setText(dc.getFormato()); // formato
            jTextField9.setText(dc.getIdentifier()); // id
            jTextField10.setText(dc.getSource()); // fonte
            jTextField11.setText(getStringFromList(dc.getLinguaggi())); // fonte
            jTextField11.setSize(6, 22);
            jTextField11.setPreferredSize(new Dimension(6, 22));
            jTextField12.setText(getStringFromList(dc.getRelazioni())); // relazioni
            jTextField12.setSize(6, 22);
            jTextField12.setPreferredSize(new Dimension(6, 22));
            jTextField2.setText(getStringFromList(dc.getContributi())); // contributi
            jTextField2.setSize(6, 22);
            jTextField2.setPreferredSize(new Dimension(6, 22));
            jTextField13.setText(dc.getCopertura()); // coverage
            jTextField14.setText(dc.getDiritti()); // diritti

            // dati aggiuntivi
            jTextField15.setText(dc.getDataCreazione());
            jTextField16.setText(dc.getCitta());
            jTextField17.setText(dc.getNazione());
        } else {
            jPanel3.setVisible(true);
            jLabel18.setText("L'immagine non contiene metadati XMP.");
        }
        //jTextField15.setText(dc.get);

    }

    private String getStringFromList(List<String> list) {
        String output = "";
        if (list != null && list.size() > 0) {
            for (int i = 0; i < list.size(); i++) {
                if (i == list.size() - 1) {
                    output += list.get(i);
                } else {
                    output += list.get(i) + ", ";
                }
            }
        }
        return output;
    }

    private String getStringFromListDate(List<Calendar> list) {
        String output = "";
        SimpleDateFormat sdf = new SimpleDateFormat("MM-dd-yyyy");
        if (list != null && list.size() > 0) {
            for (int i = 0; i < list.size(); i++) {
                if (i == list.size() - 1) {
                    output += sdf.format(list.get(i).getTime());
                } else {
                    output += sdf.format(list.get(i).getTime()) + ", ";
                }
            }
        }
        return output;
    }

    private List<String> getListFromString(String list) {
        List<String> output = new ArrayList<String>();
        if (list != null && !list.equals("")) {
            String[] c = list.split(",");
            for (int i = 0; i < c.length; i++) {
                output.add(c[i].trim());
            }
        }
        return output;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jTextField4 = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jTextField5 = new javax.swing.JTextField();
        jTextField6 = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jTextField7 = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jTextField8 = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        jTextField9 = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jTextField10 = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        jTextField11 = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        jTextField12 = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jTextField13 = new javax.swing.JTextField();
        jLabel15 = new javax.swing.JLabel();
        jTextField14 = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jLabel19 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jTextField15 = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jTextField16 = new javax.swing.JTextField();
        jLabel17 = new javax.swing.JLabel();
        jTextField17 = new javax.swing.JTextField();
        jButton4 = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        jLabel18 = new javax.swing.JLabel();
        jButton5 = new javax.swing.JButton();

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Metadati XMP", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N
        ij.util.Java2.setSystemLookAndFeel();

        jLabel2.setText("Autore");

        jTextField1.setToolTipText("valore1, valore2, ... valoreN");
        jTextField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextField1FocusGained(evt);
            }
        });

        jLabel3.setText("Descrizione");

        jLabel4.setText("Titolo");

        jLabel5.setText("Soggetti");

        jTextField4.setToolTipText("valore1, valore2, ... valoreN");

        jLabel6.setText("Editore");

        jTextField5.setToolTipText("valore1, valore2, ... valoreN");

        jTextField6.setToolTipText("dd-mm-yyyy, ");
        jTextField6.setMaximumSize(new java.awt.Dimension(6, 22));
        jTextField6.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextField6FocusGained(evt);
            }
        });

        jLabel7.setText("Data");

        jLabel8.setText("Tipo");

        jTextField7.setMaximumSize(new java.awt.Dimension(6, 22));

        jLabel9.setText("Formato");

        jLabel10.setText("Id");

        jLabel11.setText("Fonte");

        jLabel12.setText("Lingua");

        jTextField11.setToolTipText("valore1, valore2, ... valoreN");
        jTextField11.setMaximumSize(new java.awt.Dimension(6, 22));

        jLabel13.setText("Relazioni");

        jTextField12.setToolTipText("valore1, valore2, ... valoreN");

        jLabel14.setText("Copertina");

        jLabel15.setText("Diritti");

        jTextArea1.setColumns(20);
        jTextArea1.setFont(new java.awt.Font("Arial", 0, 11)); // NOI18N
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jLabel19.setText("Contributi");

        jTextField2.setToolTipText("valore1, valore2, ... valoreN");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(30, 30, 30)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel10, javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel12, javax.swing.GroupLayout.Alignment.TRAILING)))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jLabel14)
                                .addGap(4, 4, 4)))
                        .addGap(15, 15, 15)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, 161, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextField11, javax.swing.GroupLayout.PREFERRED_SIZE, 161, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(5, 5, 5)
                                .addComponent(jLabel19)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jTextField2))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGap(9, 9, 9)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel13)
                                    .addComponent(jLabel15))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTextField14)
                                    .addComponent(jTextField12)))))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel4)
                            .addComponent(jLabel5)
                            .addComponent(jLabel7)
                            .addComponent(jLabel9)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField1)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jTextField4)
                                    .addComponent(jTextField6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jTextField8)
                                    .addComponent(jTextField9, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 161, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jLabel8)
                                    .addComponent(jLabel6)
                                    .addComponent(jLabel11))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jTextField10)
                                    .addComponent(jTextField5, javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jTextField7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                            .addComponent(jTextField3)
                            .addComponent(jScrollPane1))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel3)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(jTextField5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(jTextField7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel9)
                    .addComponent(jLabel11)
                    .addComponent(jTextField10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(jTextField9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel19)
                    .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel12)
                    .addComponent(jTextField12, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(jTextField14, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel15)
                    .addComponent(jTextField13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(0, 18, Short.MAX_VALUE))
        );

        jButton1.setText("Salva");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Annulla");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("RDF");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Dati aggiuntivi", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N
        ij.util.Java2.setSystemLookAndFeel();

        jLabel1.setText("Data creazione");

        jTextField15.setToolTipText("dd-mm-yyyy");
        jTextField15.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jTextField15FocusGained(evt);
            }
        });

        jLabel16.setText("Citta'");

        jLabel17.setText("Nazione");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1)
                    .addComponent(jLabel17))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jTextField17, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
                    .addComponent(jTextField15))
                .addGap(31, 31, 31)
                .addComponent(jLabel16)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextField16)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextField15, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel16)
                    .addComponent(jTextField16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel17))
                .addGap(0, 10, Short.MAX_VALUE))
        );

        jButton4.setText("Modifica");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jLabel18.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel18.setForeground(new java.awt.Color(0, 51, 51));
        jLabel18.setText("-");
        jLabel18.setToolTipText("");

        jButton5.setIcon(new javax.swing.ImageIcon(getClass().getResource("/it/sc/xmpplugin/img/warning.gif"))); // NOI18N
        jButton5.setBorderPainted(false);
        jButton5.setContentAreaFilled(false);
        jButton5.setFocusPainted(false);
        jButton5.setFocusable(false);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(8, 8, 8)
                .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel18)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel18, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(99, 99, 99)
                        .addComponent(jButton1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton3)
                        .addGap(0, 99, Short.MAX_VALUE))
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(7, 7, 7)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2)
                    .addComponent(jButton3)
                    .addComponent(jButton4))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        RdfUI rdf = new RdfUI();
        rdf.RdfUIDialog(pathFileSource, fileName);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        if (!ValidazioneUtil.validaCampo(jTextField1, Costanti.STRING, true)) {
            jTextField1.setBackground(Color.ORANGE);
            JOptionPane.showMessageDialog(null, "Verificare campo", "Errore",
                    JOptionPane.ERROR_MESSAGE);
        } else if (!ValidazioneUtil.validaCampo(jTextField6, Costanti.DATE, false)) {
            jTextField6.setBackground(Color.ORANGE);
            JOptionPane.showMessageDialog(null, "Verificare campo", "Errore",
                    JOptionPane.ERROR_MESSAGE);
        } else if (!ValidazioneUtil.validaCampo(jTextField15, Costanti.DATE, false)) {
            jTextField15.setBackground(Color.ORANGE);
            JOptionPane.showMessageDialog(null, "Verificare campo", "Errore",
                    JOptionPane.ERROR_MESSAGE);
        } else {
            //boolean errore = false;
            fc = new JFileChooser();
            int returnVal = fc.showSaveDialog(XMPMetadataUI.this);
            try {
                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    final File file = fc.getSelectedFile();
                    
                    if(!file.getPath().substring(file.getPath().lastIndexOf(".")+1, file.getPath().length()).equalsIgnoreCase("jpg") &&
                            !file.getPath().substring(file.getPath().lastIndexOf(".")+1, file.getPath().length()).equalsIgnoreCase("jpeg")) {
                        JOptionPane.showMessageDialog(null, "Il file deve avere estensione JPG o JPEG.",
                            "Errore", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                    
                    FormData formData = new FormData();

                    formData.setAutori(getListFromString(jTextField1.getText()));
                    formData.setDescrizione(jTextArea1.getText());
                    formData.setTitolo(jTextField3.getText());
                    formData.setSoggetti(getListFromString(jTextField4.getText()));
                    formData.setEditori(getListFromString(jTextField5.getText()));
                    formData.setDate(getDateListFromString(jTextField6.getText()));

                    formData.setTipi(getListFromString(jTextField7.getText()));
                    formData.setFormato(jTextField8.getText());
                    formData.setIdentifier(jTextField9.getText());
                    formData.setSource(jTextField10.getText());

                    formData.setLinguaggi(getListFromString(jTextField11.getText()));
                    formData.setRelazioni(getListFromString(jTextField12.getText()));
                    formData.setContributi(getListFromString(jTextField2.getText()));

                    formData.setCopertura(jTextField13.getText());
                    formData.setDiritti(jTextField14.getText());

                    formData.setCitta(jTextField16.getText());
                    formData.setDataCreazione(jTextField15.getText());
                    formData.setNazione(jTextField17.getText());

                    GestioneXMP.writeXMPFromJPEG(pathFileSource, file.getPath(), formData, false);

                    JOptionPane.showMessageDialog(null, "Metadati salvati correttamente.",
                            "Info", JOptionPane.INFORMATION_MESSAGE);

                    dispose();

                }
            } catch (Exception e) {
                //errore = true;
                JOptionPane.showMessageDialog(null, "Impossibile salvare i metadati sul file: " + e.getMessage(),
                        "Errore", JOptionPane.ERROR_MESSAGE);
            }

        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        boolean errore = false;
        //fc = new JFileChooser();
        //int returnVal = fc.showSaveDialog(XMPMetadataUI.this);
        try {
            //if (returnVal == JFileChooser.APPROVE_OPTION) {
            //final File file = fc.getSelectedFile();

            FormData formData = new FormData();

            formData.setAutori(getListFromString(jTextField1.getText()));
            formData.setDescrizione(jTextArea1.getText());
            formData.setTitolo(jTextField3.getText());
            formData.setSoggetti(getListFromString(jTextField4.getText()));
            formData.setEditori(getListFromString(jTextField5.getText()));
            formData.setDate(getDateListFromString(jTextField6.getText()));

            formData.setTipi(getListFromString(jTextField7.getText()));
            formData.setFormato(jTextField8.getText());
            formData.setIdentifier(jTextField9.getText());
            formData.setSource(jTextField10.getText());

            formData.setLinguaggi(getListFromString(jTextField11.getText()));
            formData.setRelazioni(getListFromString(jTextField12.getText()));
            formData.setContributi(getListFromString(jTextField2.getText()));

            formData.setCopertura(jTextField13.getText());
            formData.setDiritti(jTextField14.getText());

            formData.setCitta(jTextField16.getText());
            formData.setDataCreazione(jTextField15.getText());
            formData.setNazione(jTextField17.getText());

            GestioneXMP.modifyXMPFromJPEG(pathFileSource, pathFileSource, formData);

            //}
        } catch (Exception e) {
            errore = true;
            JOptionPane.showMessageDialog(null, "Impossibile salvare i metadati sul file: " + e.getMessage(),
                    "Errore", JOptionPane.ERROR_MESSAGE);
        }
        if (!errore) {
            JOptionPane.showMessageDialog(null, "Metadati salvati correttamente.",
                    "Info", JOptionPane.INFORMATION_MESSAGE);
        }
        dispose();
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jTextField6FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField6FocusGained
        jTextField6.setBackground(Color.WHITE);
    }//GEN-LAST:event_jTextField6FocusGained

    private void jTextField15FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField15FocusGained
        jTextField15.setBackground(Color.WHITE);
    }//GEN-LAST:event_jTextField15FocusGained

    private void jTextField1FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField1FocusGained
        jTextField1.setBackground(Color.WHITE);
    }//GEN-LAST:event_jTextField1FocusGained

    private Calendar convertStringToCalendar(String strDate) {
        DateFormat formatter;
        Date date;
        Calendar cal = null;
        try {
            //String strDate = "11-June-07";
            formatter = new SimpleDateFormat("dd-MM-yyyy");
            date = (Date) formatter.parse(strDate);
            cal = Calendar.getInstance();
            cal.setTime(date);
            System.out.println("Today is " + date);
        } catch (Exception e) {
            System.out.println("Exception :" + e);
        }
        return cal;
    }

    private List<Calendar> getDateListFromString(String list) {
        List<Calendar> output = new ArrayList<Calendar>();
        if (list != null && !list.equals("")) {
            String[] c = list.split(",");
            for (int i = 0; i < c.length; i++) {
                output.add(convertStringToCalendar(c[i].trim()));
            }
        }
        return output;
    }

    private boolean validazioneCampi(FormData formData) {

        if (!jTextField6.getText().matches("\\d{2}\\\\d{2}\\\\d{4}")) {
            return false;
        }
        return true;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField10;
    private javax.swing.JTextField jTextField11;
    private javax.swing.JTextField jTextField12;
    private javax.swing.JTextField jTextField13;
    private javax.swing.JTextField jTextField14;
    private javax.swing.JTextField jTextField15;
    private javax.swing.JTextField jTextField16;
    private javax.swing.JTextField jTextField17;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    private javax.swing.JTextField jTextField8;
    private javax.swing.JTextField jTextField9;
    // End of variables declaration//GEN-END:variables
}
