package it.sc.xmpplugin.main;

import ij.IJ;
import ij.ImagePlus;
import ij.WindowManager;
import ij.plugin.PlugIn;
import it.sc.xmpplugin.gui.XMPMetadataUI;
import it.sc.xmpplugin.presentation.FormData;

public class XMPPlugin extends ImagePlus implements PlugIn {

    @Override
    public void run(String arg) {
        
        String fileName = "";
        ImagePlus imp = WindowManager.getCurrentImage();
        if (imp == null) {
            IJ.noImage();
            return;
        }
        fileName = imp.getOriginalFileInfo().fileName;

        System.out.println("file name:" + imp.getOriginalFileInfo().directory);
        System.out.println("file name:" + imp.getOriginalFileInfo().fileName);
        
        if(!fileName.substring(fileName.lastIndexOf(".")+1, fileName.length()).equalsIgnoreCase("jpg") 
                && !fileName.substring(fileName.lastIndexOf(".")+1, fileName.length()).equalsIgnoreCase("jpeg")) {
            IJ.error("Errore", "Il plugin e' compatibile con file di estensione JPG o JPEG.");
            return;
        }

        /*
         OpenDialog od = new OpenDialog("Open JPEG...", arg);
         String directory = od.getDirectory();
         String name = od.getFileName();
         if (name == null) {
         return;
         }
         */



        //String path = directory + name;
        String path = imp.getOriginalFileInfo().directory + "\\" + imp.getOriginalFileInfo().fileName;
        try {
            XMPMetadataUI xmp = new XMPMetadataUI();
            FormData dc = GestioneXMP.readXMPFromJPEG(path);
            xmp.xmpMetadataUIDialog(dc, path, imp.getOriginalFileInfo().fileName);
        } catch (Exception e) {
            e.printStackTrace();
            
        }


    }
}
