package it.sc.xmpplugin.main;

import java.io.*;

public class XMPReader {

	public static final String namespace = "http://ns.adobe.com/xap/1.0/";
	
	/*
	public static void main(String[] args) throws IOException {
		File f = new File("c:\\1_xmp3.jpg");
		String xmp = new XMPReader().getXMP(f);
		System.out.println(xmp);
	}
	*/

	public String getXMP(File f) throws IOException {
		FileInputStream is = new FileInputStream(f);
		int i = 0;
		String result = null;
		while ((i = is.read()) != -1)
			if (i == 0xFF && is.read() == 0xE1) {
				result = checkNamespace(is);
				if (result != null)
					break;
			}
		return result;
	}

	private String checkNamespace(FileInputStream is) throws IOException {
		String s = getSegment(is);
		return (s.startsWith(namespace)) ? s.substring(29) : null;
	}

	private String getSegment(InputStream is) throws IOException {
		DataInputStream dis = new DataInputStream(is);
		byte[] buffer = new byte[dis.readShort() - 2];
		dis.read(buffer);
		return new String(buffer);
	}

}
