package it.sc.xmpplugin.utils;

import it.sc.xmpplugin.Costanti;
import java.awt.Color;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.JTextField;

/**
 *
 * @author Salvo Corsaro
 */
public class ValidazioneUtil {

    public static boolean validaCampo(JTextField text, int type, boolean mandatory) {

        Pattern patternString = Pattern.compile("[A-Za-z_%:]*");
        Pattern patternAlfaNum = Pattern.compile("[A-Za-z0-9\\s_%:-]+");
        Pattern patternNumber = Pattern.compile("[/d]");
        Pattern patternEmail = Pattern.compile("/^([a-zA-Z0-9_.-])+@([a-zA-Z0-9_.-])+.([a-zA-Z])+([a-zA-Z])+/");
        //Pattern patternPath = Pattern.compile("([a-zA-Z]:)?(\\\\[a-zA-Z0-9._-]+)+\\\\?");
        //Pattern patternDate = Pattern.compile("[0-9]{2}-[0-9]{2}-[0-9]d{4}");
        //Pattern patternString = Pattern.compile("[\\D\\s]");
        Matcher match = null;

        if (type == Costanti.NUMBER) {
            if (mandatory && isEmpty(text)) {
                return false;
            }
            match = patternNumber.matcher(String.valueOf(text.getText()));
            if (!isEmpty(text) || !match.matches()) {
                marcaCampo((JTextField) text, Costanti.INVALID);
                return false;
            }
        } else if (type == Costanti.STRING) {
            if (mandatory && isEmpty(text)) {
                return false;
            }
            match = patternString.matcher(String.valueOf(text.getText()));
            if (!match.matches()) {
                marcaCampo((JTextField) text, Costanti.INVALID);
                return false;
            }
        } else if (type == Costanti.ALFANUMERICO) {
            if (mandatory && isEmpty(text)) {
                return false;
            }
            match = patternAlfaNum.matcher(String.valueOf(text.getText()));
            if (!isEmpty(text) || !match.matches()) {
                marcaCampo((JTextField) text, Costanti.INVALID);
                return false;
            }
        } else if (type == Costanti.EMAIL) {
            if (mandatory && isEmpty(text)) {
                return false;
            }
            match = patternEmail.matcher(String.valueOf(text.getText()));
            if (!isEmpty(text) || !match.matches()) {
                marcaCampo((JTextField) text, Costanti.INVALID);
                return false;
            }
        } else if (type == Costanti.PATH) {
            if (!isEmpty(text)) {
                return false;
            }
        } else if (type == Costanti.DATE) {
            if (mandatory && isEmpty(text)) {
                return false;
            } else {
                if (!isEmpty(text) && !isValidDate(text.getText())) {
                    marcaCampo((JTextField) text, Costanti.INVALID);
                    return false;
                }
            }

        }

        return true;
    }

    private static void marcaCampo(JTextField jTextField, int how) {
        switch (how) {
            case Costanti.INVALID:
                jTextField.setBackground(Color.ORANGE);
            case Costanti.EMPTY:
                jTextField.setBackground(Color.WHITE);
        }

    }

    private static boolean isEmpty(JTextField jTextField) {
        if (jTextField != null && jTextField.getText() != null && !jTextField.getText().equals("")) {
            return false;
        }
        return true;
    }

    private static boolean isValidDate(String date) {

        SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yyyy");
        Date testDate = null;

        try {
            testDate = sdf.parse(date);
        } catch (ParseException e) {
            return false;
        }

        if (!sdf.format(testDate).equals(date)) {
            return false;
        }
        return true;

    }
}
